/* $Id: rlogin.h,v 1.3 1993/09/10 17:17:12 ppessi Exp $
 *
 * rlogin.h --- interface to the remote login 
 *
 * Author: ppessi <Pekka.Pessi@hut.fi>
 *
 * Copyright (c) 1993 AmiTCP/IP Group, <amitcp-group@hut.fi>
 *                    Helsinki University of Technology, Finland.
 *                    All rights reserved.
 *
 * Created      : Tue May 18 13:53:15 1993 ppessi
 * Last modified: Fri Sep 10 15:19:29 1993 ppessi
 *
 * $Log: rlogin.h,v $
 * Revision 1.3  1993/09/10  17:17:12  ppessi
 * Changed passing of host in rcmd().
 *
 * Revision 1.2  1993/08/12  06:19:13  jraja
 * Updated the email-address.
 *
 * Revision 1.1  1993/05/19  17:32:55  ppessi
 * Initial revision
 *
 */

/* pty OOB commands */
#define		TIOCPKT_DATA		0x00	/* data packet */
#define		TIOCPKT_FLUSHREAD	0x01	/* flush packet */
#define		TIOCPKT_FLUSHWRITE	0x02	/* flush packet */
#define		TIOCPKT_STOP		0x04	/* stop output */
#define		TIOCPKT_START		0x08	/* start output */
#define		TIOCPKT_NOSTOP		0x10	/* no more ^S, ^Q */
#define		TIOCPKT_DOSTOP		0x20	/* now do ^S ^Q */
#define		TIOCPKT_IOCTL		0x40	/* state change of pty driver */
#define	        TIOCPKT_WINDOW	        0x80    /* do window size */

struct winsize_packet {
    char title[4];
    unsigned short ws_row, ws_col;
    unsigned short ws_xpixel, ws_ypixel;
};

extern struct winsize_packet winsize;
extern char okwinch;
extern int errno;

/* resources allocated */
extern BYTE IO_bit;
extern BYTE URG_bit;
extern ULONG SIGURG;
extern struct Library *SocketBase;

void CloseSocketBase(void);
void rsendwsize(int s);
int rcmd(char **host, u_short rport, 
	 const char *locuser, const char *remuser, const char *term);
int rread(long s, char *buf, int length);
